<template>
    <v-list flat class="transparent-bg">
        <v-list-item-group v-model="selectedDashboardMenu" color="white">
            <v-list-item
                v-for="(menu, m) in menus"
                :key="'menu-' + m"
                :class="[
                    {
                        'border-top-dark-grey': menu === 0,
                    },
                    'border-bottom-dark-grey pl-0 pr-0',
                ]"
                @click="goToPage(menu.id)"
            >
                <v-list-item-content>
                    <v-list-item-title
                        class="font-14 font-metropolis-regular"
                        v-text="$t('dashboard.menu.' + m)"
                    ></v-list-item-title>
                </v-list-item-content>

                <v-list-item-action
                    v-if="
                        menu.id === menus.PROFILE.id && profilePercentage < 100
                    "
                >
                    <v-chip icon class="badge">
                        {{ profilePercentage }}%
                    </v-chip>
                </v-list-item-action>
                <v-list-item-icon>
                    <v-icon>mdi-chevron-right</v-icon>
                </v-list-item-icon>
            </v-list-item>
        </v-list-item-group>
    </v-list>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'

@Component({
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        profilePercentage: 'user/getProfilePercentage',
        user: 'user/getUser',
    }),
})
export default class MenuBar extends Vue {
    // Data
    $cookies: any
    menus!: any

    // Getters
    get selectedDashboardMenu() {
        return this.$store.getters['menu/getSelectedDashboardMenu']
    }

    set selectedDashboardMenu(value: Boolean) {
        this.$store.commit('menu/setDashboardMenu', value)
    }

    // Methods
    goToPage(id: Number) {
        switch (id) {
            case this.menus.HOME.id:
                this.$router.push(this.menus.HOME.path)
                break

            case this.menus.PROFILE.id:
                this.$router.push(this.menus.PROFILE.path)
                break

            case this.menus.ADDRESS.id:
                this.$router.push(this.menus.ADDRESS.path)
                break

            case this.menus.ORDERS.id:
                this.$router.push(this.menus.ORDERS.path)
                break

            case this.menus.SUBSCRIPTION.id:
                this.$router.push(this.menus.SUBSCRIPTION.path)
                break

            case this.menus.PAYMENT.id:
                this.$router.push(this.menus.PAYMENT.path)
                break

            case this.menus.CHANGEPASSWORD.id:
                this.$router.push(this.menus.CHANGEPASSWORD.path)
                break

            case this.menus.SIGNOUT.id:
                this.logout()
                break

            default:
                this.$router.push('/')
                break
        }
    }

    logout() {
        // Remove token cookie
        this.$cookies.remove('t')

        // Remove order cookie
        this.$cookies.remove('o')

        // Remove secret cookie
        this.$cookies.remove('s')

        // Remove token from axios instance
        this.$axios.setToken(false)

        // Clear Stores
        // Clear user profile
        this.$store.commit('user/clearUser')

        // Clear addresses
        this.$store.commit('user/clearAddresses')

        // Clear subscription
        this.$store.commit('subscription/clearSubscription')

        // Clear wishlist
        this.$store.commit('wishlist/clearWishlist')

        // Clear cart
        this.$store.commit('cart/clearCart')

        // Clear shop cart
        this.$store.commit('cart/clearCartShop')

        // Display snackbar
        const val = {
            text: this.$t('snackbar.logoutSuccess'),
            color: 'green',
            icon: 'mdi-check',
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)

        // FB Logout
        // window.FB.logout()

        // Redirect
        this.$router.push('/')
    }
}
</script>
